function	[nuGd,deGd]=c2dd(muG,gG,freG,fcoG,T,tau)

% La funzione 	[nuGd,deGd]=c2dd(nuG,deG,T,tau);
% oppure	[nuGd,deGd]=c2dd(muG,gG,freG,fcoG,T,tau);
%
% calcola numeratore e denominatore della funzione di trasferimento di un
% sistema ibrido esternamente a tempo discreto costituito dalla cascata di
% uno ZOH, un ritardo tau, un sistema dinamico a tempo continuo con funzio-
% ne di trasferimento razionale G(s) (nuG e deG sono il numeratore e il de-
% nominatore di G) e un campionatore periodico ideale di periodo T, sincro-
% no e in fase con lo ZOH. In mancanza, tau=0.

% G.O.Guardabassi, marzo 1995.

if nargin > 4 
	[nuG,deG]=f2nd(muG,gG,freG,fcoG);
	if nargin < 6, tau=0; end
else
	nuG=muG;
	deG=gG;
	T=freG;
	if nargin== 4, tau=fcoG; end
	if nargin < 4, tau=0; end
end

[a,b,c,d]=tf2ss(nuG,deG);
[f,g]=c2d(a,b,T);

if tau == 0
	[nuGd,deGd]=ss2tf(f,g,c,d,1);
else
	r=fix(tau/T);
	tr=rem(tau,T);
	[ft,g]=c2d(a,b,T-tr);
	[s,gt]=c2d(a,b,tr);
	Fi=[f ft*gt;zeros(size(c)) 0];
	M=[g; 1];
	N=[c d];
	[nuGd,deGd]=ss2tf(Fi,M,N,0,1);
	deGd=[deGd zeros(1,r)];
end

nuGd=[zeros(1,length(deGd)-length(nuGd)) nuGd];
