function  [fim,wc,gam,wpi,muRv,gRv,freRv,fcoRv,wmasL,masL,w,mL,fL,mF]=...
		cadbode1(ii,muR,gR,freR,fcoR,muG,gG,freG,fcoG,muRv,gRv,freRv,fcoRv)
	 
% [mdf,omegac,mdg,omegap,muRv,gRv,freRv,fcoRv]=
%			=cadbode1(i,muX,gX,freX,fcoX,muG,gG,freG,fcoG,muRv,gRv,freRv,fcoRv);
% E' una funzione di servizio chiamata da cadbode.
% Se i=1, X=L (f. di tr. d'anello desiderata); altrimenti, X=R (controllore).
% G		  sistema sotto controllo
% Rv       controllore analizzato al passo precedentemente
% mdf  	  margine di fase
% omegac   pulsazione critica
% mdg      margine di guadagno
% omegap   pulsazioni di attraversamento del semiasse reale negativo

% G.O.Guardabassi, 19 marzo 1998, 27 febbraio 2000


N=500;

%if nargin <= 7 , fcoG=[];end
%if nargin <= 6 , freG=[];end
%if nargin <= 5 , gG=0 ;  end
%if nargin <= 4 , muG=1;  end
%if nargin <= 3 , fcoR=[];end
%if nargin <= 2 , freR=[];end

if ii==1 	%%%%%%%%%%%%%% In questo caso, muR,gR,freR,fcoR descrive L
	muR=muR/muG;
	if ((gG > 0) & (gG > gR)) | ((gG < 0) & (gG < gR))
	    disp(' ')
	    disp('   ******************* ATTENZIONE! ********************')
	    disp('   * La funzione di trasferimento d''anello desiderata *')
	    disp('   * produce una cancellazione illegittima  polo/zero *')
	    disp('   * nell''origine. Occorre modificarla.               *')
	    disp('   ****************************************************')
	    disp(' ')
	    return
	end
	gR=gR-gG;

	if isempty(freG), freGinv=[];
	else
		ipir=find(freG(1,:)<0&freG(2,:)<0);
		izir=find(freG(1,:)<0&freG(2,:)>0);
		for k=1:length(izir)
			izirk=find(freR(1,:)==freG(1,izir(k)));
			if isempty(izirk) | freG(2,izirk)>freR(2,izirk)
	    	    		disp(' ')
	    	    		disp('   ******************* ATTENZIONE! ********************')
	    	    		disp('   * La funzione di trasferimento d''anello desiderata *')
	    	    		disp('   * produce la illegittima cancellazione di uno zero *')
	    	    		disp('   * reale.                      Occorre modificarla. *')
	    	    		disp('   ****************************************************')
	    	    		disp(' ')
	    	    		return
			end
		end
		freGinv=freG;
		freGinv(2,:)=-freG(2,:);
	end
	freR=[freR freGinv];
	if ~isempty(freR)
		[freR(1,:),isre]=sort(freR(1,:));
		freR(2,:)=freR(2,isre);
		for k=2:length(freR(1,:))
			if k<=length(freR(1,:))
			    if freR(1,k)==freR(1,k-1)
					freR(2,k-1)=freR(2,k-1)+freR(2,k);
					freR=[freR(:,1:k-1) freR(:,k+1:length(freR(1,:)))];
			    end
			end
		end
		inz=find(freR(2,:)~=0);
		freR=freR(:,inz);
	end
   
   ipic=[];
	if isempty(fcoG) , fcoGinv=[];
	else
		ipic=find(fcoG(2,:)<0&fcoG(3,:)<0);
		izic=find(fcoG(2,:)<0&fcoG(3,:)>0);
		for k=1:length(izic)
			izick=find(fcoR(1,:)==fcoG(1,izic(k)));
			for kk=1:length(izick)
				izickk=find(fcoR(2,izick)==fcoG(2,izick(kk)));
				if isempty(izirkk) | fcoG(3,izickk)>fcoR(3,izickk) 
	    	    			disp(' ')
	    	    			disp('   ******************* ATTENZIONE! ********************')
	    	    			disp('   * La funzione di trasferimento d''anello desiderata *')
	    	    			disp('   * produce la illegittima cancellazione di zeri com-*')
	    	    			disp('   * plessi.                     Occorre modificarla. *')
	    	    			disp('   ****************************************************')
	    	    			disp(' ')
	    	    			return
				end
			end
		end
		fcoGinv=fcoG;
		fcoGinv(3,:)=-fcoG(3,:);
	end
	fcoR=[fcoR fcoGinv];

	if length(ipir)+length(ipic) > 0
	    disp(' ')
	    disp('   ******************* ATTENZIONE! ********************')
	    disp('   * L''impianto e'' instabile!    Il metodo di sintesi *')
	    disp('   * qui considerato non e'' applicabile.              *')
	    disp('   *            Si puo'' procedere solo per tentativi. *')
	    disp('   ****************************************************')
	    disp(' ')
	    return
	end

	if ~isempty(fcoR)
		[fcoR(1,:),isco]=sort(fcoR(1,:));
		fcoR(2:3,:)=fcoR(2:3,isco);
		for k=2:length(fcoR(1,:))
			if k<=length(fcoR(1,:))
			    if fcoR(1:2,k)==fcoR(1:2,k-1)
				fcoR(3,k-1)=fcoR(3,k-1)+fcoR(3,k);
				fcoR=[fcoR(:,1:k-1) fcoR(:,k+1:length(fcoR(1,:)))];
			    end
			end
		end
		inz=find(fcoR(3,:)~=0);
		fcoR=fcoR(:,inz);
	end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Da qui in poi muR,gR,freR,fcoR specificano il controllore.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if ~isempty(freG) , grelGre=-sum(freG(2,:)); else grelGre=0; end
if ~isempty(fcoG) , grelGco=-2*sum(fcoG(3,:)); else grelGco=0; end
grelG=gG+grelGre+grelGco;
if ~isempty(freR) , grelRre=-sum(freR(2,:)); else grelRre=0; end
if ~isempty(fcoR) , grelRco=-2*sum(fcoR(3,:)); else grelRco=0; end
grelR=gR+grelRre+grelRco;
grelRG=grelR+grelG;

if (nargin <= 1)|(grelRG <= 0)
	disp(' ')
	disp('* Il controllore non e'' specificato, oppure c''e'' un')
	disp(' ')
	disp('                                   ANELLO ALGEBRICO.')
	disp(' ')
	return
end

muL=muR*muG;
gL=gR+gG;
freL=[freR freG];
fcoL=[fcoR fcoG];

%%%%%%%%%%%%%%%%%%%% Adesso occorre verificare che in L=RG non ci siano
%%%%%%%%%%%%%%%%%%%%              cancellazioni illegittime
%%%%%%%%%%%%%%%%%%%% ed effettuare quelle legittime "riducendo" freL e fcoL

if ~isempty(freL) 
	[fre(1,:),ord]=sort(freL(1,:));
   fre(2,:)=freL(2,ord);
else
   fre=[];
end

if ~isempty(fcoL) 
	[fco(1,:),ord]=sort(fcoL(1,:));
	fco(2:3,:)=fcoL(2:3,ord);
else
	fco=[];   
end

ic=[];
[nr,nc]=size(fre);
if nc==1,ic=[1];end 
for k=2:nc
	if abs((fre(1,k)-fre(1,k-1))/fre(1,k)) < .001
		if (fre(2,k)*fre(2,k-1) < 0)&(fre(1,k)<0)
 	    		disp(' ')
    	    		disp('   ******************* ATTENZIONE! ********************')
	    	    	disp('   * Il controllore proposto produce la illegittima   *')
	    	    	disp('   * cancellazione di (almeno) un polo reale.         *')
	    	    	disp('   *                            Occorre modificarlo.  *')
	    	    	disp('   ****************************************************')
	    	    	disp(' ')
	    	    	return
		end
		fre(2,k)=fre(2,k)+fre(2,k-1);
	else
		if fre(2,k-1)~=0, ic=[ic k-1]; end
	end
	if k==nc & fre(2,k)~=0, ic=[ic k]; end
end
fre=fre(:,ic);

ic=[];
[nr,nc]=size(fco);
if nc==1,ic=[1];end
for k=2:nc
	eps1=abs((fco(1,k)-fco(1,k-1))/fco(1,k));
	eps2=abs(fco(2,k)-fco(2,k-1));
	if (eps1 < .001) & (eps2 < .001)
		if (fco(3,k)*fco(3,k-1) < 0)&(fco(2,k)<=0)
 	    		disp(' ')
    	    		disp('   ******************* ATTENZIONE! ********************')
	    	    	disp('   * Il controllore proposto produce la illegittima   *')
	    	    	disp('   * cancellazione di (almeno) due poli compl. con.   *')
	    	    	disp('   *                            Occorre modificarlo.  *')
	    	    	disp('   ****************************************************')
	    	    	disp(' ')
	    	    	return
		end
		fco(3,k)=fco(3,k)+fco(3,k-1);
	else
		if fco(3,k-1)~=0, ic=[ic k-1]; end
	end
	if k==nc & fco(3,k)~=0, ic=[ic k]; end
end
fco=fco(:,ic);

freL=fre;
fcoL=fco;

wang=[];
if ~isempty(freR), wang=[wang ones(size(freR(1,:)))./freR(1,:)]; end
if ~isempty(freG), wang=[wang ones(size(freG(1,:)))./freG(1,:)]; end
if ~isempty(fcoR), wang=[wang fcoR(1,:)]; end
if ~isempty(fcoG), wang=[wang fcoG(1,:)]; end
wang=abs(wang);

wmin=min(wang)/3; wmax=max(wang)*3;
d1=floor(log10(wmin)); d2=ceil(log10(wmax));
w1=10^d1; w2=10^d2;

[nuR,deR]=f2nd(muR,gR,freR,fcoR);
[nuG,deG]=f2nd(muG,gG,freG,fcoG);
[nuL,deL]=f2nd(muL,gL,freL,fcoL);
[masR,wmasR]=as(muR,gR,freR,fcoR,w1,w2);
[masG,wmasG]=as(muG,gG,freG,fcoG,w1,w2);
[masL,wmasL]=as(muL,gL,freL,fcoL,w1,w2);

w=logspace(d1,d2,400);
[mL,fL]=bode(nuL,deL,w);
mL=20*log10(mL);
wc=zeri(w,mL);
omegac=wc;
fim=[];
if length(wc)>1
	disp(' ')
	disp(' ***  La pulsazione critica non e'' unica.')
	disp(' ***  Il calcolo del margine di fase e'' omesso.')
	disp(' ')
elseif length(wc)==1
	ifim=find(w>=wc);
	kfim=ifim(1);
	if kfim==1, fLc=fL(1);
	else
		fLc=fL(kfim-1)+(fL(kfim)-fL(kfim-1))*(wc-w(kfim-1))/(w(kfim)-w(kfim-1));
	end
	fim=180-abs(fLc);
end
wpi=zeri(w,fL+180*ones(size(fL)));
if ~isempty(wpi)
	mLpi=bode(nuL,deL,wpi);
	gam=1/max(mLpi);
else 
	gam=NaN;
end
mF=20*log10(bode(nuL,deL+nuL,w));

muLv=muRv*muG;
gLv=gRv+gG;
freLv=[freRv freG];
fcoLv=[fcoR fcoG];
[masLv,wmasLv]=as(muLv,gLv,freLv,fcoLv,w1,w2);

MM=max([masL masR masLv]);
mm=min([masL masR masLv]);
dm=MM-mm;
Min=mm-.1*dm;Max=MM+.1*dm;
am=[w1 w2 -30 10];af=[w1 w2 -180 -120]; 

clc
disp(' ')
disp('**************************** ATTENZIONE ****************************')
disp('* Seguiranno i diagrammi di Bode asintotici del modulo             *')
disp('* relativi a:                                                      *')
disp('*    L,R e Lp:=L-precedente (al 1 tentativo, Lp=G)      (Fig.1)   *')
disp('*    L su scala espansa (anche non asintotico)           (Fig.2-a) *')
disp('* e il diagramma di Bode dell''argomento relativo a:                *')
disp('*    L su scala fissa (margini di fase e --> di guadagno)(Fig.2-b) *')
disp('* Per vedere la prima figura, o per passare alla successiva,       *')
disp('*                                                BATTERE UN TASTO. *')
disp('********************************************************************')
disp(' ')
pause;

figure(1)
    semilogx(wmasL,masL,'-b',wmasLv,masLv,':b',wmasR,masR,'--m',w1*[1 1],...
    [Min Max],'k',[w1 w2],[0 0],'-k'),xlabel('pulsazione [rad/udt]')
 	 title('Diagrammi di Bode asintotici del modulo:  L      R   -------- Lp')
 	 ylabel('modulo [dB]')
	 grid,pause;
figure(2)
    subplot(211),semilogx(wmasL,masL,'-b',w,mL,':b',[w1 w2],[0 0],'-k'),grid
    ylabel('modulo [dB]'),title('Diagrammi di Bode di L :  asintotici      esatti')
    axis(am),subplot(212),semilogx(w,fL,':b'),grid,ylabel('argomento []')
	 xlabel('pulsazione [rad/udt]'),axis(af),pause;subplot

muRv=muR;gRv=gR;freRv=freR;fcoRv=fcoR;
wmasLv=wmasL;masLv=masL;
clc
