% Se p e' un vettore che rappresenta un polinomio,
%				c=routh(p)
% fornisce (come vettore riga c) la prima colonna della Tabella di Routh T
% relativa a p;  
%				[c,T]=routh(p) 
% fornisce anche la tabella T.
%
% 				c=routh(p,1) 
% fornisce (come vettore riga c) la prima colonna della Tabella T di Jury,  
% o di "Routh a tempo discreto"; 
%      		[c,T]=routh(p,1) 
% fornisce anche T. 

% G.O.Guardabassi, 12 febbraio 1995

function [c,T]=routh(a,i)

in=find(a~=0);
a=a(in(1):length(a));
[nr,nc]=size(a);
na=nc;
if nr > nc, a=a'; na=nr; end
n=na-1;

if nargin < 2, i=0; end

if i ~= 1
	T(1,:)=a(1:2:2*fix(n/2)+1);
	m=length(T(1,:));
	b=a(2:2:2*fix((n+1)/2));
	T(2,:)=[b zeros(1,m-length(b))];
	for k=1:n-1
	   	T(k+2,:)=zeros(1,m);
	   	for i=1:m-1
			T(k+2,i)=T(k,i+1)-T(k,1)*T(k+1,i+1)/T(k+1,1);
	   	end
	end
else
	if a(1) < 0, a=-a; end
	T=zeros(na,na);
	T(1,:)=a;
	for k=1:n
		ap=T(k,1:na-k+1);
		ak=ap-ap(na-k+1:-1:1)*ap(na-k+1)/ap(1);
		T(k+1,1:na-k)=ak(1:na-k);
	end
end

c=T(:,1)';


