% La funzione     [nuRtm,deRtm,nuRrp,deRrp]=tmrpd(nuGd,deGd);
%
% calcola numeratore e denominatore del controllore in tempo minimo (nuRtm,
% deRtm) e del controllore a risposta piatta (nuRrp,deRrp) per un sistema 
% sotto controllo nel quale la funzione di trasferimento dall'uscita u# del
% controllore digitale all'uscita y* del campionatore sia Gd(z).
%
% 	nuGd,deGd	sono numeratore e denominatore di Gd(z)

% G.O.Guardabassi, dicembre 1997.

function	[nuRtm,deRtm,nuRrp,deRrp]=tmrp(nuGd,deGd)

[a,b,c,d]=tf2ss(nuGd,deGd);
if abs(d)>0
    disp('*')
    disp('* ATTENZIONE!')
    disp('* Il sistema sotto controllo non e'' dinamico in senso proprio.')
    disp('* Il calcolo e'' deliberatamente interrotto.')
    disp('*')
    return
end
pGd=roots(deGd);
indi=find(abs(pGd)>=1);
if length(indi) > 0,
    disp('*')
    disp('* ATTENZIONE!')
    disp('* Il sistema sotto controllo non e'' asintoticamente stabile.')
    disp('* Il calcolo e'' deliberatamente interrotto.')
    disp('*')
    return
end

nuRrp=deGd;
deRrp=-nuGd;
deRrp(1)=sum(nuGd);
inz=find(abs(deRrp)>0);
nuRrp=nuRrp/deRrp(inz(1));
deRrp=deRrp(inz(1):length(deRrp))/deRrp(inz(1));

zGd=roots(nuGd);
izfGd=find(abs(zGd)>=1);
nuGdt=nuGd;
nuLo=1;
for k=1:length(izfGd)
	nuGdt=deconv(nuGdt,[1 -zGd(izfGd(k))]);
	nuLo=conv(nuLo,[1 -zGd(izfGd(k))]);
end
nuRtm=deGd/sum(nuLo);
nuLo=nuLo/sum(nuLo);
deLo=[1 zeros(1,length(pGd)-length(zGd)-1) -nuLo];
deRtm=conv(nuGdt,deLo);
inz=find(abs(deRtm)>0);
nuRtm=nuRtm/deRtm(inz(1));
deRtm=deRtm(inz(1):length(deRtm))/deRtm(inz(1));
