function       xz=zeri(x,y)

% La funzione               xz=zeri(x,y);      
%
% fornisce una stima degli zeri di una funzione continua y(x) data per punti
% (anche disordinati). Gli elementi di ugual indice di x e di y rappresenta-
% no, rispettivamente, un valore dell'argomento e il corrispondente valore 
% della funzione. Il vettore xz contiene una stima degli zeri della funzione
% nell'intervallo [min(x), max(x)].

% G.O. Guardabassi, 2 gennaio 1998  

[p,q]=size(x);
n=q;
s=0;
if p>q, x=x'; n=p; s=1; end
[p,q]=size(y);
if p==q & s==1, y=y'; end
if p>q & p==n, y=y'; end
[p,q]=size(y);

if n ~= q
	disp(' ')
	disp('ATTENZIONE!')
	disp(' ')
	disp('I vettori x e y devono avere la stessa lunghezza.')
	disp(' ')
	disp('                           ESECUZIONE INTERROTTA')
	disp(' ')
	return
end

[x,is]=sort(x);
for k=1:p
	yk=y(k,:);
	y(k,:)=yk(is);
end

if n<50 & p==1
	X=linspace(min(x),max(x),500);
	y=spline(x,y,X);
	x=X; n=500;
end	

xz1=x(ceil(find(y==0)'/p));
dx=diff(x);

if p==1
	yy=y(1:n-1).*y(2:n);
	ii=find(yy<0);
	dy=diff(y);
	xz2=x(ii)+dx(ii).*abs(y(ii)./dy(ii));
	xz=sort([xz1 xz2]);
else
	ncurve=p*ones(1,n)-sum(isnan(y));
	dcurve=ncurve(2:n)-ncurve(1:n-1);
	ireg=find(dcurve==0);
	isalt=find(abs(dcurve)>0);
	dy=diff(y')';
	yy=y(:,1:n-1).*y(:,2:n);
	for k=1:p
		ii=find(yy(k,ireg)<0);
		xzr=x(ireg(ii))+dx(ireg(ii)).*abs(y(k,ireg(ii))./dy(k,ireg(ii)));
		xz=[xz xzr];
	end

	bm=0;
	for k=1:length(isalt)
		h=isalt(k);
		ch=y(:,h:h+1);
		if ncurve(h)==1 & sum(find(ch(1,1)*ch(:,2)<0))>0
			ich=find(ch(1,1)*ch(:,2)<0);
			xzk=x(h)+dx(h)*abs(ch(1,1)/(ch(ich(1),2)-ch(1,1)));
			xz=[xz xzk];
		elseif ncurve(h+1)==1 & sum(find(ch(1,2)*ch(:,1)<0))>0
			ich=find(ch(1,2)*ch(:,1)<0);
			xzk=x(h)+dx(h)*abs(ch(ich(1),1)/(ch(1,2)-ch(ich(1),1)));
			xz=[xz xzk];
		else
			bm=bm+1;
		end
	end
	if bm>1
		disp(' ')
		disp('*** ATTENZIONE! ***')
		disp('La funzione presenta biforcazioni secondarie.')
		disp('Eventuali zeri coincidenti con tali biforcazioni non')
		disp('sono rilevati.  Soluzione potenzialmente incompleta.')
		disp('    Per continuare,                BATTERE UN TASTO.')
		disp(' ')
		pause
	end	
	xz=sort([xz xz1]);
end		
			

